/*!
 * dragtable
 *
 * @Version 2.0.12
 *
 * Copyright (c) 2010-2013, Andres akottr@gmail.com
 * Dual licensed under the MIT (MIT-LICENSE.txt)
 * and GPL (GPL-LICENSE.txt) licenses.
 *
 * Inspired by the the dragtable from Dan Vanderkam (danvk.org/dragtable/)
 * Thanks to the jquery and jqueryui comitters
 *
 * Any comment, bug report, feature-request is welcome
 * Feel free to contact me.
 */

/* TOKNOW:
 * For IE7 you need this css rule:
 * table {
 *   border-collapse: collapse;
 * }
 * Or take a clean reset.css (see http://meyerweb.com/eric/tools/css/reset/)
 */

/* TODO: investigate
 * Does not work properly with css rule:
 * html {
 *      overflow: -moz-scrollbars-vertical;
 *  }
 * Workaround:
 * Fixing Firefox issues by scrolling down the page
 * http://stackoverflow.com/questions/2451528/jquery-ui-sortable-scroll-helper-element-offset-firefox-issue
 *
 * var start = $.noop;
 * var beforeStop = $.noop;
 * if($.browser.mozilla) {
 * var start = function (event, ui) {
 *               if( ui.helper !== undefined )
 *                 ui.helper.css('position','absolute').css('margin-top', $(window).scrollTop() );
 *               }
 * var beforeStop = function (event, ui) {
 *              if( ui.offset !== undefined )
 *                ui.helper.css('margin-top', 0);
 *              }
 * }
 *
 * and pass this as start and stop function to the sortable initialisation
 * start: start,
 * beforeStop: beforeStop
 */
/*
 * Special thx to all pull requests comitters
 */
!function (e) { function t() { var t = e('<style id="__dragtable_disable_text_selection__" type="text/css">body { -ms-user-select:none;-moz-user-select:-moz-none;-khtml-user-select:none;-webkit-user-select:none;user-select:none; }</style>'); e(document.head).append(t), e(document.body).attr("onselectstart", "return false;").attr("unselectable", "on"), window.getSelection ? window.getSelection().removeAllRanges() : document.selection.empty() } function i() { e("#__dragtable_disable_text_selection__").remove(), n ? e(document.body).attr("onselectstart", n) : e(document.body).removeAttr("onselectstart"), a ? e(document.body).attr("unselectable", a) : e(document.body).removeAttr("unselectable") } function o(e, t) { var i = e.parentNode, o = e.nextSibling === t ? e : e.nextSibling; t.parentNode.insertBefore(e, t), i.insertBefore(t, o) } e.widget("akottr.dragtable", { options: { revert: !1, dragHandle: ".table-handle", maxMovingRows: 1, excludeFooter: !1, onlyHeaderThreshold: 100, dragaccept: null, persistState: null, restoreState: null, exact: !0, clickDelay: 10, containment: null, cursor: "move", cursorAt: !1, distance: 0, tolerance: "pointer", axis: "x", beforeStart: e.noop, beforeMoving: e.noop, beforeReorganize: e.noop, beforeStop: e.noop }, originalTable: { el: null, selectedHandle: null, sortOrder: null, startIndex: 0, endIndex: 0 }, sortableTable: { el: e(), selectedHandle: e(), movingRow: e() }, persistState: function () { var t = this; this.originalTable.el.find("th").each(function (e) { "" !== this.id && (t.originalTable.sortOrder[this.id] = e) }), e.ajax({ url: this.options.persistState, data: this.originalTable.sortOrder }) }, _restoreState: function (t) { for (var i in t) this.originalTable.startIndex = e("#" + i).closest("th").prevAll().size() + 1, this.originalTable.endIndex = parseInt(t[i] + 1, 10), this._bubbleCols() }, _bubbleCols: function () { var e, t, i, n, a = this.originalTable.startIndex, l = this.originalTable.endIndex, s = this.originalTable.el.children(); if (this.options.excludeFooter && (s = s.not("tfoot")), l > a) for (e = a; l > e; e++) for (i = s.find("> tr > td:nth-child(" + e + ")").add(s.find("> tr > th:nth-child(" + e + ")")), n = s.find("> tr > td:nth-child(" + (e + 1) + ")").add(s.find("> tr > th:nth-child(" + (e + 1) + ")")), t = 0; t < i.length; t++) o(i[t], n[t]); else for (e = a; e > l; e--) for (i = s.find("> tr > td:nth-child(" + e + ")").add(s.find("> tr > th:nth-child(" + e + ")")), n = s.find("> tr > td:nth-child(" + (e - 1) + ")").add(s.find("> tr > th:nth-child(" + (e - 1) + ")")), t = 0; t < i.length; t++) o(i[t], n[t]) }, _rearrangeTableBackroundProcessing: function () { var t = this; return function () { t._bubbleCols(), t.options.beforeStop(t.originalTable), t.sortableTable.el.remove(), i(), null !== t.options.persistState && (e.isFunction(t.options.persistState) ? t.options.persistState(t.originalTable) : t.persistState()) } }, _rearrangeTable: function () { var e = this; return function () { e.originalTable.selectedHandle.removeClass("dragtable-handle-selected"), e.sortableTable.el.sortable("disable"), e.sortableTable.el.addClass("dragtable-disabled"), e.options.beforeReorganize(e.originalTable, e.sortableTable), e.originalTable.endIndex = e.sortableTable.movingRow.prevAll().size() + 1, setTimeout(e._rearrangeTableBackroundProcessing(), 50) } }, _generateSortable: function (i) { !i.cancelBubble && (i.cancelBubble = !0); for (var o = this, n = this.originalTable.el[0].attributes, a = "", l = 0; l < n.length; l++) n[l].nodeValue && "id" != n[l].nodeName && "width" != n[l].nodeName && (a += n[l].nodeName + '="' + n[l].nodeValue + '" '); var s = [], r = []; this.originalTable.el.find("tr").slice(0, this.options.maxMovingRows).each(function () { for (var t = this.attributes, i = "", o = 0; o < t.length; o++) t[o].nodeValue && "id" != t[o].nodeName && (i += " " + t[o].nodeName + '="' + t[o].nodeValue + '"'); s.push(i), r.push(e(this).height()) }); var d = [], h = 0, c = o.originalTable.el.children(); if (this.options.excludeFooter && (c = c.not("tfoot")), c.find("> tr > th").each(function () { var t = e(this).outerWidth(); d.push(t), h += t }), o.options.exact) { var b = h - o.originalTable.el.outerWidth(); d[0] -= b } h += 2; var u = '<ul class="dragtable-sortable" style="position:absolute; width:' + h + 'px;">'; c.find("> tr > th").each(function (t) { u += "<li>", u += "<table " + a + ">"; var i = c.find("> tr > th:nth-child(" + (t + 1) + ")"); o.options.maxMovingRows > 1 && (i = i.add(c.find("> tr > td:nth-child(" + (t + 1) + ")").slice(0, o.options.maxMovingRows - 1))), i.each(function (t) { var i = e(this).clone().wrap("<div></div>").parent().html(); 0 === i.toLowerCase().indexOf("<th") && (u += "<thead>"), u += "<tr " + s[t] + '" style="height:' + r[t] + 'px;">', u += i, 0 === i.toLowerCase().indexOf("<th") && (u += "</thead>"), u += "</tr>" }), u += "</table>", u += "</li>" }), u += "</ul>", this.sortableTable.el = this.originalTable.el.before(u).prev(), this.sortableTable.el.find("> li > table").each(function (t) { e(this).css("width", d[t] + "px") }), this.sortableTable.selectedHandle = this.sortableTable.el.find("th .dragtable-handle-selected"); var g = this.options.dragaccept ? "li:has(" + this.options.dragaccept + ")" : "li"; this.sortableTable.el.sortable({ items: g, stop: this._rearrangeTable(), revert: this.options.revert, tolerance: this.options.tolerance, containment: this.options.containment, cursor: this.options.cursor, cursorAt: this.options.cursorAt, distance: this.options.distance, axis: this.options.axis }), this.originalTable.startIndex = e(i.target).closest("th").prevAll().size() + 1, this.options.beforeMoving(this.originalTable, this.sortableTable), this.sortableTable.movingRow = this.sortableTable.el.find("> li:nth-child(" + this.originalTable.startIndex + ")"), t(), this.sortableTable.movingRow.trigger(e.extend(e.Event(i.type), { which: 1, clientX: i.clientX, clientY: i.clientY, pageX: i.pageX, pageY: i.pageY, screenX: i.screenX, screenY: i.screenY })); var p = this.sortableTable.el.find(".ui-sortable-placeholder"); !p.height() <= 0 && p.css("height", this.sortableTable.el.find(".ui-sortable-helper").height()), p.html('<div class="outer" style="height:100%;"><div class="inner" style="height:100%;"></div></div>') }, bindTo: {}, _create: function () { this.originalTable = { el: this.element, selectedHandle: e(), sortOrder: {}, startIndex: 0, endIndex: 0 }, this.bindTo = this.originalTable.el.find("th"), this.options.dragaccept && (this.bindTo = this.bindTo.filter(this.options.dragaccept)), this.bindTo.find(this.options.dragHandle).size() > 0 && (this.bindTo = this.bindTo.find(this.options.dragHandle)), null !== this.options.restoreState && (e.isFunction(this.options.restoreState) ? this.options.restoreState(this.originalTable) : this._restoreState(this.options.restoreState)); var t = this; this.bindTo.mousedown(function (i) { 1 === i.which && t.options.beforeStart(t.originalTable) !== !1 && (clearTimeout(this.downTimer), this.downTimer = setTimeout(function () { t.originalTable.selectedHandle = e(this), t.originalTable.selectedHandle.addClass("dragtable-handle-selected"), t._generateSortable(i) }, t.options.clickDelay)) }).mouseup(function () { clearTimeout(this.downTimer) }) }, redraw: function () { this.destroy(), this._create() }, destroy: function () { this.bindTo.unbind("mousedown"), e.Widget.prototype.destroy.apply(this, arguments) } }); var n = e(document.body).attr("onselectstart"), a = e(document.body).attr("unselectable") }(jQuery);